/* acconfig.h
   This file is in the public domain.

   Descriptive text for the C preprocessor macros that
   the distributed Autoconf macros can define.
   No software package will use all of them; autoheader copies the ones
   your configure.in uses into your configuration header file templates.

   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  Although this order
   can split up related entries, it makes it easier to check whether
   a given entry is in the file.

   Leave the following blank line there!!  Autoheader needs it.  */


/* Define if compiler can handle ANSI prototypes.  */
#undef ANSI_C

/* Define if autoconf/configure has already been run.  */
#undef AUTOCONF

/* Define if this system uses a 32-bit DOS extender (djgpp/emx).  */
#undef DOS32

/* Define if <errno.h> declares errno.  */
#undef EXTERN_ERRNO

/* Define if you are using the GNU readline library.  */
#undef GNU_READLINE

/* Define if you have Thomas Boutell's gd library.  */
#undef HAVE_LIBGD

/* Define if you have the png library.  */
#undef HAVE_LIBPNG

/* Define if this is a Linux system with SuperVGA library.  */
#undef LINUXVGA

/* Define if this is an MSDOS system with djgpp.  */
#undef MSDOS

/* Define if you do not have the bcopy function.  */
#undef NOCOPY

/* Define if you do not want to read .gnuplotrc in the current directory.  */
#undef NOCWDRC

/* Define if you do not have the atexit function.  */
#undef NO_ATEXIT

/* Define if you do not have the <errno.h> header file.  */
#undef NO_ERRNO_H

/* Define if you do not have the <float.h> header file.  */
#undef NO_FLOAT_H

/* Define if you do not have the <limits.h> header file.  */
#undef NO_LIMITS_H

/* Define if you do not have the <locale.h> header file.  */
#undef NO_LOCALE_H

/* Define if you do not have the memcpy function.  */
#undef NO_MEMCPY

/* Define if you do not have the memset function.  */
#undef NO_MEMSET

/* Define if you do not have the <stdlib.h> header file.  */
#undef NO_STDLIB_H

/* Define if you do not have the strchr function.  */
#undef NO_STRCHR

/* Define if you do not have the <string.h> header file.  */
#undef NO_STRING_H

/* Define if you do not have the <sys/types.h> header file.  */
#undef NO_SYS_TYPES_H

/* Define if you do not have the <time.h> header file.  */
#undef NO_TIME_H

/* Define if you do not have the <sys/select.h> header file.  */
#undef OLD_SELECT

/* Define if you do have the popen and pclose functions.  */
#undef PIPES

/* Define if you have the function prototypes.  */
#undef PROTOTYPES

/* Define if you want to use the included readline function.  */
#undef READLINE

/* Define if you are using the X11 window system.  */
#undef X11

/* Define to `long' if <sys/types.h> doesn't define.  */
#undef time_t


/* Leave that blank line there!!  Autoheader needs it.
   If you're adding to this file, keep in mind:
   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  */
